%global optflags       %{__global_cflags} -m64 -mtune=generic

Summary: 	Facebook Open-source Library
Name: 		folly
#Version: 	2016.07.26
Version: 	2016.07.26
Release: 	2%{?dist}
License: 	APLv2.0
Group: 		Development/Languages
URL: 		https://github.com/facebook/folly
#Source: https://github.com/facebook/folly/archive/v0.57.0.tar.gz
Source: 	%{name}-%{version}.tar.gz
Source1:	https://googletest.googlecode.com/files/gtest-1.7.0.zip
Patch1:		fixmalloctest.patch
Patch2:		fixes.patch
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	devtoolset-2-gcc-c++ double-conversion-devel environment-modules devtoolset-2-build devtoolset-2-binutils devtoolset-2-libquadmath-devel
#BuildRequires:	double-conversion-devel environment-modules devtoolset-3-build devtoolset-3-toolchain
BuildRequires:	autoconf269 automake libtool autoconf-archive
BuildRequires:	lz4-devel lzma-devel snappy-devel zlib-devel scons openssl-devel libevent-devel glog-devel gflags-devel
BuildRequires:	boost160-devel
#BuildRequires:	libdwarf-devel devtoolset-3-elfutils-libelf-devel libunwind-devel

%description
Folly is an open-source C++ library developed and used at Facebook.

%package devel
Summary: 	Header files and static libraries for folly
Group: 		Development/Libraries
Requires: 	%{name} = %{version}
Requires:	double-conversion-devel lz4-devel lzma-devel snappy-devel zlib-devel scons openssl-devel libevent-devel glog-devel gflags-devel boost160-devel

%description devel
Development files for folly library.

%prep
%setup
%patch1 -p1 -b .fixmalloctest
%patch2 -p1 -b .fixes
cd folly/test
unzip %{SOURCE1}

%build
. /etc/profile.d/modules.sh
module load rh autoconf boost
cd folly
autoreconf -ivf
%configure --with-boost=$BOOSTHOME --with-boost-libdir=$BOOSTHOME/%{_lib}
%{__make} %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot}
. /etc/profile.d/modules.sh
module load rh autoconf boost
cd folly
%{__make} install DESTDIR="%{buildroot}"
rm -f %{buildroot}%{_libdir}/lib*.la

# for now skip test, linking trouble
#if 0
%check
. /etc/profile.d/modules.sh
module load rh autoconf boost
cd folly
%{__make} check
#endif

%clean
%{__rm} -rf %{buildroot}


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-, root, root, 0755)
%doc LICENSE README.md
%{_libdir}/lib*.so.*

%files devel
%defattr(-, root, root, 0755)
%doc folly/docs/*
%{_includedir}/folly
%{_libdir}/lib*.a
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/libfolly.pc

%changelog
* Tue Sep 22 2015 Josko Plazonic <plazonic@princeton.edu>
- initial build
